Package com.google.android.exoplayer2.extractor.mkv

## Class MatroskaExtractor

- java.lang.Object
- - com.google.android.exoplayer2.extractor.mkv.MatroskaExtractor

- All Implemented Interfaces:
    `Extractor`

      public class MatroskaExtractor
      extends Object
      implements Extractor

  Extracts data from the Matroska and WebM container formats.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class | Description
    --- | --- | ---
    `static interface` | `MatroskaExtractor.Flags` | Flags controlling the behavior of the extractor.
    `protected static class` | `MatroskaExtractor.Track` | Holds data corresponding to a single track.

    - ### Nested classes/interfaces inherited from interface com.google.android.exoplayer2.extractor.Extractor

      `Extractor.ReadResult`

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static ExtractorsFactory` | `FACTORY` | Factory for `MatroskaExtractor` instances.
    `static int` | `FLAG_DISABLE_SEEK_FOR_CUES` | Flag to disable seeking for cues.

    - ### Fields inherited from interface com.google.android.exoplayer2.extractor.Extractor

      `RESULT_CONTINUE, RESULT_END_OF_INPUT, RESULT_SEEK`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `MatroskaExtractor()` |
    `MatroskaExtractor​(@com.google.android.exoplayer2.extractor.mkv.MatroskaExtractor.Flags int flags)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `protected void` | `binaryElement​(int id, int contentSize, ExtractorInput input)` | Called when a binary element is encountered.
    `protected void` | `endMasterElement​(int id)` | Called when the end of a master element is encountered.
    `protected void` | `floatElement​(int id, double value)` | Called when a float element is encountered.
    `protected MatroskaExtractor.Track` | `getCurrentTrack​(int currentElementId)` | Returns the track corresponding to the current TrackEntry element.
    `protected @com.google.android.exoplayer2.extractor.mkv.EbmlProcessor.ElementType int` | `getElementType​(int id)` | Maps an element ID to a corresponding type.
    `protected void` | `handleBlockAddIDExtraData​(MatroskaExtractor.Track track, ExtractorInput input, int contentSize)` |
    `protected void` | `handleBlockAdditionalData​(MatroskaExtractor.Track track, int blockAdditionalId, ExtractorInput input, int contentSize)` |
    `void` | `init​(ExtractorOutput output)` | Initializes the extractor with an `ExtractorOutput`.
    `protected void` | `integerElement​(int id, long value)` | Called when an integer element is encountered.
    `protected boolean` | `isLevel1Element​(int id)` | Checks if the given id is that of a level 1 element.
    `int` | `read​(ExtractorInput input, PositionHolder seekPosition)` | Extracts data read from a provided `ExtractorInput`.
    `void` | `release()` | Releases all kept resources.
    `void` | `seek​(long position, long timeUs)` | Notifies the extractor that a seek has occurred.
    `boolean` | `sniff​(ExtractorInput input)` | Returns whether this extractor can extract samples from the `ExtractorInput`, which must provide data from the start of the stream.
    `protected void` | `startMasterElement​(int id, long contentPosition, long contentSize)` | Called when the start of a master element is encountered.
    `protected void` | `stringElement​(int id, String value)` | Called when a string element is encountered.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### FACTORY

          public static final ExtractorsFactory FACTORY

      Factory for `MatroskaExtractor` instances.

    - #### FLAG_DISABLE_SEEK_FOR_CUES

          public static final int FLAG_DISABLE_SEEK_FOR_CUES

      Flag to disable seeking for cues.

      Normally (i.e. when this flag is not set) the extractor will seek to the cues element if its position is specified in the seek head and if it's after the first cluster. Setting this flag disables seeking to the cues element. If the cues element is after the first cluster then the media is treated as being unseekable.

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### MatroskaExtractor

          public MatroskaExtractor()

    - #### MatroskaExtractor

          public MatroskaExtractor​(@com.google.android.exoplayer2.extractor.mkv.MatroskaExtractor.Flags int flags)

  - ### Method Detail

    - #### sniff

          public final boolean sniff​(ExtractorInput input)
                              throws IOException

      Description copied from interface: `Extractor`
      Returns whether this extractor can extract samples from the `ExtractorInput`, which must provide data from the start of the stream.

      If `true` is returned, the `input`'s reading position may have been modified. Otherwise, only its peek position may have been modified.

      Specified by:
        `sniff` in interface `Extractor`
      Parameters:
        `input` - The `ExtractorInput` from which data should be peeked/read.
      Returns:
        Whether this extractor can read the provided input.
      Throws:
        `IOException` - If an error occurred reading from the input.

    - #### init

          public final void init​(ExtractorOutput output)

      Description copied from interface: `Extractor`
      Initializes the extractor with an `ExtractorOutput`. Called at most once.
      Specified by:
        `init` in interface `Extractor`
      Parameters:
        `output` - An `ExtractorOutput` to receive extracted data.

    - #### seek

          @CallSuper
          public void seek​(long position,
                           long timeUs)

      Description copied from interface: `Extractor`
      Notifies the extractor that a seek has occurred.

      Following a call to this method, the `ExtractorInput` passed to the next invocation of `Extractor.read(ExtractorInput, PositionHolder)` is required to provide data starting from `position` in the stream. Valid random access positions are the start of the stream and positions that can be obtained from any `SeekMap` passed to the `ExtractorOutput`.

      Specified by:
        `seek` in interface `Extractor`
      Parameters:
        `position` - The byte offset in the stream from which data will be provided.
        `timeUs` - The seek time in microseconds.

    - #### release

          public final void release()

      Description copied from interface: `Extractor`
      Releases all kept resources.
      Specified by:
        `release` in interface `Extractor`

    - #### read

          public final int read​(ExtractorInput input,
                                PositionHolder seekPosition)
                         throws IOException

      Description copied from interface: `Extractor`
      Extracts data read from a provided `ExtractorInput`. Must not be called before `Extractor.init(ExtractorOutput)`.

      A single call to this method will block until some progress has been made, but will not block for longer than this. Hence each call will consume only a small amount of input data.

      In the common case, `Extractor.RESULT_CONTINUE` is returned to indicate that the `ExtractorInput` passed to the next read is required to provide data continuing from the position in the stream reached by the returning call. If the extractor requires data to be provided from a different position, then that position is set in `seekPosition` and `Extractor.RESULT_SEEK` is returned. If the extractor reached the end of the data provided by the `ExtractorInput`, then `Extractor.RESULT_END_OF_INPUT` is returned.

      When this method throws an `IOException`, extraction may continue by providing an `ExtractorInput` with an unchanged `read position` to a subsequent call to this method.

      Specified by:
        `read` in interface `Extractor`
      Parameters:
        `input` - The `ExtractorInput` from which data should be read.
        `seekPosition` - If `Extractor.RESULT_SEEK` is returned, this holder is updated to hold the position of the required data.
      Returns:
        One of the `RESULT_` values defined in this interface.
      Throws:
        `IOException` - If an error occurred reading from or parsing the input.

    - #### getElementType

          @CallSuper
          protected @com.google.android.exoplayer2.extractor.mkv.EbmlProcessor.ElementType int getElementType​(int id)

      Maps an element ID to a corresponding type.
      See Also:
        `EbmlProcessor.getElementType(int)`

    - #### isLevel1Element

          @CallSuper
          protected boolean isLevel1Element​(int id)

      Checks if the given id is that of a level 1 element.
      See Also:
        `EbmlProcessor.isLevel1Element(int)`

    - #### startMasterElement

          @CallSuper
          protected void startMasterElement​(int id,
                                            long contentPosition,
                                            long contentSize)
                                     throws ParserException

      Called when the start of a master element is encountered.
      Throws:
        `ParserException`
      See Also:
        `EbmlProcessor.startMasterElement(int, long, long)`

    - #### endMasterElement

          @CallSuper
          protected void endMasterElement​(int id)
                                   throws ParserException

      Called when the end of a master element is encountered.
      Throws:
        `ParserException`
      See Also:
        `EbmlProcessor.endMasterElement(int)`

    - #### integerElement

          @CallSuper
          protected void integerElement​(int id,
                                        long value)
                                 throws ParserException

      Called when an integer element is encountered.
      Throws:
        `ParserException`
      See Also:
        `EbmlProcessor.integerElement(int, long)`

    - #### floatElement

          @CallSuper
          protected void floatElement​(int id,
                                      double value)
                               throws ParserException

      Called when a float element is encountered.
      Throws:
        `ParserException`
      See Also:
        `EbmlProcessor.floatElement(int, double)`

    - #### stringElement

          @CallSuper
          protected void stringElement​(int id,
                                       String value)
                                throws ParserException

      Called when a string element is encountered.
      Throws:
        `ParserException`
      See Also:
        `EbmlProcessor.stringElement(int, String)`

    - #### binaryElement

          @CallSuper
          protected void binaryElement​(int id,
                                       int contentSize,
                                       ExtractorInput input)
                                throws IOException

      Called when a binary element is encountered.
      Throws:
        `IOException`
      See Also:
        `EbmlProcessor.binaryElement(int, int, ExtractorInput)`

    - #### handleBlockAddIDExtraData

          protected void handleBlockAddIDExtraData​(MatroskaExtractor.Track track,
                                                   ExtractorInput input,
                                                   int contentSize)
                                            throws IOException

      Throws:
        `IOException`

    - #### handleBlockAdditionalData

          protected void handleBlockAdditionalData​(MatroskaExtractor.Track track,
                                                   int blockAdditionalId,
                                                   ExtractorInput input,
                                                   int contentSize)
                                            throws IOException

      Throws:
        `IOException`

    - #### getCurrentTrack

          protected MatroskaExtractor.Track getCurrentTrack​(int currentElementId)
                                                     throws ParserException

      Returns the track corresponding to the current TrackEntry element.
      Throws:
        `ParserException` - if the element id is not in a TrackEntry.